#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>

void pixel(int xc, int yc, int x, int y);

int main()
{
    int gd = DETECT, gm, xc, yc, r, x, y, pk;
    initgraph(&gd, &gm, "C:\\TURBOC3\\BGI");

    printf("***Bresenham's Midpoint Algorithm of circle***\n");
    printf("Enter the value of xc\t");
    scanf("%d", &xc);
    printf("Enter the value of yc\t");
    scanf("%d", &yc);
    printf("Enter the radius of circle\t");
    scanf("%d", &r);

    x = 0;
    y = r;
    pk = 2 * (1 - r);

    pixel(xc, yc, x, y);

    while (x <= y)
    {
        if (pk < 0)
        {
            x = x + 1;
            pk = pk + 2 * x + 1;
        }
        else
        {
            x = x + 1;
            y = y - 1;
            pk = pk + 2 * x - 2 * y + 1;
        }
        pixel(xc, yc, x, y);
    }

    getch();
    closegraph();
    return 0;
}

void pixel(int xc, int yc, int x, int y)
{
    putpixel(xc + x, yc + y, 7);
    putpixel(xc + y, yc + x, 7);
    putpixel(xc - y, yc + x, 7);
    putpixel(xc - x, yc + y, 7);
    putpixel(xc - x, yc - y, 7);
    putpixel(xc - y, yc - x, 7);
    putpixel(xc + y, yc - x, 7);
    putpixel(xc + x, yc - y, 7);
}